{
    "$graph": [
        {
            "class": "Workflow",
            "id": "#main",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "id": "#main/abra_ram_min"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#main/bams"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/covariates"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".idx"
                    ],
                    "id": "#main/dbsnp"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".idx"
                    ],
                    "id": "#main/hapmap"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".idx"
                    ],
                    "id": "#main/indels_1000g"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/intervals"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "record",
                            "fields": [
                                {
                                    "type": "string",
                                    "name": "#main/pair/CN"
                                },
                                {
                                    "type": "string",
                                    "name": "#main/pair/ID"
                                },
                                {
                                    "type": "string",
                                    "name": "#main/pair/LB"
                                },
                                {
                                    "type": "string",
                                    "name": "#main/pair/PL"
                                },
                                {
                                    "type": {
                                        "type": "array",
                                        "items": "string"
                                    },
                                    "name": "#main/pair/PU"
                                },
                                {
                                    "type": {
                                        "type": "array",
                                        "items": "File"
                                    },
                                    "name": "#main/pair/R1"
                                },
                                {
                                    "type": {
                                        "type": "array",
                                        "items": "File"
                                    },
                                    "name": "#main/pair/R2"
                                },
                                {
                                    "type": {
                                        "type": "array",
                                        "items": "string"
                                    },
                                    "name": "#main/pair/RG_ID"
                                },
                                {
                                    "type": "string",
                                    "name": "#main/pair/adapter"
                                },
                                {
                                    "type": "string",
                                    "name": "#main/pair/adapter2"
                                },
                                {
                                    "type": {
                                        "type": "array",
                                        "items": "File"
                                    },
                                    "name": "#main/pair/bam"
                                },
                                {
                                    "type": "string",
                                    "name": "#main/pair/bwa_output"
                                },
                                {
                                    "type": {
                                        "type": "array",
                                        "items": "File"
                                    },
                                    "name": "#main/pair/zR1"
                                },
                                {
                                    "type": {
                                        "type": "array",
                                        "items": "File"
                                    },
                                    "name": "#main/pair/zR2"
                                }
                            ]
                        }
                    },
                    "id": "#main/pair"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa",
                        ".fai",
                        "^.dict"
                    ],
                    "id": "#main/ref_fasta"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".idx"
                    ],
                    "id": "#main/snps_1000g"
                }
            ],
            "steps": [
                {
                    "run": "#abra.cwl",
                    "in": [
                        {
                            "source": "#main/abra_ram_min",
                            "id": "#main/abra/abra_ram_min"
                        },
                        {
                            "source": "#main/bams",
                            "id": "#main/abra/in"
                        },
                        {
                            "valueFrom": "${ return inputs.in.map(function(x){ return x.basename.replace(\".bam\", \".abra.bam\"); }); }",
                            "id": "#main/abra/out"
                        },
                        {
                            "source": "#main/ref_fasta",
                            "id": "#main/abra/ref"
                        },
                        {
                            "source": "#main/list2bed/output_file",
                            "id": "#main/abra/targets"
                        }
                    ],
                    "out": [
                        "#main/abra/outbams"
                    ],
                    "id": "#main/abra"
                },
                {
                    "in": [
                        {
                            "source": "#main/gatk_find_covered_intervals/fci_list",
                            "id": "#main/combine_intervals/files"
                        },
                        {
                            "valueFrom": "${ return inputs.pair[0].ID + \".\" + inputs.pair[1].ID + \".fci.list\"; }",
                            "id": "#main/combine_intervals/output_filename"
                        },
                        {
                            "source": "#main/pair",
                            "id": "#main/combine_intervals/pair"
                        }
                    ],
                    "out": [
                        "#main/combine_intervals/mergedfile"
                    ],
                    "run": {
                        "class": "CommandLineTool",
                        "baseCommand": [
                            "cat"
                        ],
                        "id": "#main/combine_intervals/combine_intervals",
                        "stdout": "$(inputs.output_filename)",
                        "requirements": [
                            {
                                "class": "InlineJavascriptRequirement"
                            },
                            {
                                "class": "MultipleInputFeatureRequirement"
                            }
                        ],
                        "inputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "File"
                                },
                                "inputBinding": {
                                    "position": 1
                                },
                                "id": "#main/combine_intervals/combine_intervals/files"
                            },
                            {
                                "type": "string",
                                "id": "#main/combine_intervals/combine_intervals/output_filename"
                            }
                        ],
                        "outputs": [
                            {
                                "type": "File",
                                "id": "#main/combine_intervals/combine_intervals/mergedfile",
                                "outputBinding": {
                                    "glob": "$(inputs.output_filename)"
                                }
                            }
                        ]
                    },
                    "id": "#main/combine_intervals"
                },
                {
                    "run": "#gatk.BaseRecalibrator.cwl",
                    "in": [
                        {
                            "source": "#main/covariates",
                            "id": "#main/gatk_base_recalibrator/covariate"
                        },
                        {
                            "source": "#main/dbsnp",
                            "id": "#main/gatk_base_recalibrator/dbsnp"
                        },
                        {
                            "source": "#main/hapmap",
                            "id": "#main/gatk_base_recalibrator/hapmap"
                        },
                        {
                            "source": "#main/indels_1000g",
                            "id": "#main/gatk_base_recalibrator/indels_1000g"
                        },
                        {
                            "source": "#main/index_bams/bam_indexed",
                            "id": "#main/gatk_base_recalibrator/input_file"
                        },
                        {
                            "valueFrom": "${return [inputs.dbsnp,inputs.hapmap, inputs.indels_1000g, inputs.snps_1000g]}",
                            "id": "#main/gatk_base_recalibrator/knownSites"
                        },
                        {
                            "valueFrom": "${ return \"recal.matrix\"; }",
                            "id": "#main/gatk_base_recalibrator/out"
                        },
                        {
                            "valueFrom": "${ return [\"BadCigar\"]; }",
                            "id": "#main/gatk_base_recalibrator/read_filter"
                        },
                        {
                            "source": "#main/ref_fasta",
                            "id": "#main/gatk_base_recalibrator/reference_sequence"
                        },
                        {
                            "source": "#main/snps_1000g",
                            "id": "#main/gatk_base_recalibrator/snps_1000g"
                        }
                    ],
                    "out": [
                        "#main/gatk_base_recalibrator/recal_matrix"
                    ],
                    "id": "#main/gatk_base_recalibrator"
                },
                {
                    "run": "#gatk.FindCoveredIntervals.cwl",
                    "in": [
                        {
                            "valueFrom": "${ return [\"3\"];}",
                            "id": "#main/gatk_find_covered_intervals/coverage_threshold"
                        },
                        {
                            "source": "#main/bams",
                            "id": "#main/gatk_find_covered_intervals/input_file"
                        },
                        {
                            "source": "#main/split_intervals/intervals",
                            "id": "#main/gatk_find_covered_intervals/intervals"
                        },
                        {
                            "source": "#main/intervals",
                            "id": "#main/gatk_find_covered_intervals/intervals_list"
                        },
                        {
                            "valueFrom": "${ return [\"20\"];}",
                            "id": "#main/gatk_find_covered_intervals/minBaseQuality"
                        },
                        {
                            "source": "#main/split_intervals/intervals_id",
                            "id": "#main/gatk_find_covered_intervals/out"
                        },
                        {
                            "source": "#main/pair",
                            "id": "#main/gatk_find_covered_intervals/pair"
                        },
                        {
                            "source": "#main/ref_fasta",
                            "id": "#main/gatk_find_covered_intervals/reference_sequence"
                        }
                    ],
                    "scatter": [
                        "#main/gatk_find_covered_intervals/intervals",
                        "#main/gatk_find_covered_intervals/out"
                    ],
                    "scatterMethod": "dotproduct",
                    "out": [
                        "#main/gatk_find_covered_intervals/fci_list"
                    ],
                    "id": "#main/gatk_find_covered_intervals"
                },
                {
                    "run": "#cmo-index.cwl",
                    "in": [
                        {
                            "source": "#main/abra/outbams",
                            "id": "#main/index_bams/bam"
                        }
                    ],
                    "scatter": [
                        "#main/index_bams/bam"
                    ],
                    "scatterMethod": "dotproduct",
                    "out": [
                        "#main/index_bams/bam_indexed"
                    ],
                    "id": "#main/index_bams"
                },
                {
                    "run": "#list2bed.cwl",
                    "in": [
                        {
                            "source": "#main/combine_intervals/mergedfile",
                            "id": "#main/list2bed/input_file"
                        },
                        {
                            "valueFrom": "${ return inputs.input_file.basename.replace(\".list\", \".bed\"); }",
                            "id": "#main/list2bed/output_filename"
                        }
                    ],
                    "out": [
                        "#main/list2bed/output_file"
                    ],
                    "id": "#main/list2bed"
                },
                {
                    "in": [
                        {
                            "source": "#main/gatk_base_recalibrator/recal_matrix",
                            "id": "#main/parallel_printreads/BQSR"
                        },
                        {
                            "source": "#main/index_bams/bam_indexed",
                            "id": "#main/parallel_printreads/input_file"
                        },
                        {
                            "source": "#main/ref_fasta",
                            "id": "#main/parallel_printreads/reference_sequence"
                        }
                    ],
                    "out": [
                        "#main/parallel_printreads/out",
                        "#main/parallel_printreads/qual_metrics",
                        "#main/parallel_printreads/qual_pdf"
                    ],
                    "scatter": [
                        "#main/parallel_printreads/input_file"
                    ],
                    "scatterMethod": "dotproduct",
                    "run": {
                        "class": "Workflow",
                        "id": "#main/parallel_printreads/parallel_printreads",
                        "inputs": [
                            {
                                "type": "File",
                                "id": "#main/parallel_printreads/parallel_printreads/BQSR"
                            },
                            {
                                "type": "File",
                                "id": "#main/parallel_printreads/parallel_printreads/input_file"
                            },
                            {
                                "type": "File",
                                "id": "#main/parallel_printreads/parallel_printreads/reference_sequence"
                            }
                        ],
                        "outputs": [
                            {
                                "type": "File",
                                "secondaryFiles": [
                                    "^.bai"
                                ],
                                "outputSource": "#main/parallel_printreads/parallel_printreads/gatk_print_reads/out_bam",
                                "id": "#main/parallel_printreads/parallel_printreads/out"
                            },
                            {
                                "type": "File",
                                "outputSource": "#main/parallel_printreads/parallel_printreads/quality_metrics/qual_file",
                                "id": "#main/parallel_printreads/parallel_printreads/qual_metrics"
                            },
                            {
                                "type": "File",
                                "outputSource": "#main/parallel_printreads/parallel_printreads/quality_metrics/qual_hist",
                                "id": "#main/parallel_printreads/parallel_printreads/qual_pdf"
                            }
                        ],
                        "steps": [
                            {
                                "run": "#gatk.PrintReads.cwl",
                                "in": [
                                    {
                                        "source": "#main/parallel_printreads/parallel_printreads/BQSR",
                                        "id": "#main/parallel_printreads/parallel_printreads/gatk_print_reads/BQSR"
                                    },
                                    {
                                        "valueFrom": "${ return ['RECALCULATE'];}",
                                        "id": "#main/parallel_printreads/parallel_printreads/gatk_print_reads/baq"
                                    },
                                    {
                                        "valueFrom": "${ return true; }",
                                        "id": "#main/parallel_printreads/parallel_printreads/gatk_print_reads/emit_original_quals"
                                    },
                                    {
                                        "source": "#main/parallel_printreads/parallel_printreads/input_file",
                                        "id": "#main/parallel_printreads/parallel_printreads/gatk_print_reads/input_file"
                                    },
                                    {
                                        "valueFrom": "${ return \"5\"; }",
                                        "id": "#main/parallel_printreads/parallel_printreads/gatk_print_reads/num_cpu_threads_per_data_thread"
                                    },
                                    {
                                        "valueFrom": "${ return inputs.input_file.basename.replace(\".bam\", \".printreads.bam\");}",
                                        "id": "#main/parallel_printreads/parallel_printreads/gatk_print_reads/out"
                                    },
                                    {
                                        "source": "#main/parallel_printreads/parallel_printreads/reference_sequence",
                                        "id": "#main/parallel_printreads/parallel_printreads/gatk_print_reads/reference_sequence"
                                    }
                                ],
                                "out": [
                                    "#main/parallel_printreads/parallel_printreads/gatk_print_reads/out_bam"
                                ],
                                "id": "#main/parallel_printreads/parallel_printreads/gatk_print_reads"
                            },
                            {
                                "run": "#picard.CollectMultipleMetrics.cwl",
                                "in": [
                                    {
                                        "source": "#main/parallel_printreads/parallel_printreads/gatk_print_reads/out_bam",
                                        "id": "#main/parallel_printreads/parallel_printreads/quality_metrics/I"
                                    },
                                    {
                                        "valueFrom": "${ return inputs.I.basename.replace(\".bam\", \".qmetrics\")}",
                                        "id": "#main/parallel_printreads/parallel_printreads/quality_metrics/O"
                                    },
                                    {
                                        "valueFrom": "${return [\"null\",\"MeanQualityByCycle\"]}",
                                        "id": "#main/parallel_printreads/parallel_printreads/quality_metrics/PROGRAM"
                                    },
                                    {
                                        "source": "#main/parallel_printreads/parallel_printreads/reference_sequence",
                                        "id": "#main/parallel_printreads/parallel_printreads/quality_metrics/REFERENCE_SEQUENCE"
                                    }
                                ],
                                "out": [
                                    "#main/parallel_printreads/parallel_printreads/quality_metrics/qual_file",
                                    "#main/parallel_printreads/parallel_printreads/quality_metrics/qual_hist"
                                ],
                                "id": "#main/parallel_printreads/parallel_printreads/quality_metrics"
                            }
                        ]
                    },
                    "id": "#main/parallel_printreads"
                },
                {
                    "in": [
                        {
                            "source": "#main/intervals",
                            "id": "#main/split_intervals/interval_list"
                        }
                    ],
                    "out": [
                        "#main/split_intervals/intervals",
                        "#main/split_intervals/intervals_id"
                    ],
                    "run": {
                        "class": "ExpressionTool",
                        "id": "#main/split_intervals/split_intervals",
                        "requirements": [
                            {
                                "class": "InlineJavascriptRequirement"
                            }
                        ],
                        "inputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "string"
                                },
                                "id": "#main/split_intervals/split_intervals/interval_list"
                            }
                        ],
                        "outputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": {
                                        "type": "array",
                                        "items": "string"
                                    }
                                },
                                "id": "#main/split_intervals/split_intervals/intervals"
                            },
                            {
                                "type": {
                                    "type": "array",
                                    "items": "string"
                                },
                                "id": "#main/split_intervals/split_intervals/intervals_id"
                            }
                        ],
                        "expression": "${ var intervals = []; var intervals_id = []; var output_object = {}; var interval_list = inputs.interval_list; while( interval_list.length > 0 ) { var interval_split = interval_list.splice(0, 10); intervals.push(interval_split); intervals_id.push(interval_split.join('_')); } output_object['intervals'] = intervals; output_object['intervals_id'] = intervals_id; return output_object; }"
                    },
                    "id": "#main/split_intervals"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/list2bed/output_file",
                    "id": "#main/covint_bed"
                },
                {
                    "type": "File",
                    "outputSource": "#main/combine_intervals/mergedfile",
                    "id": "#main/covint_list"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "outputSource": "#main/parallel_printreads/out",
                    "id": "#main/outbams"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/parallel_printreads/qual_metrics",
                    "id": "#main/qual_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/parallel_printreads/qual_pdf",
                    "id": "#main/qual_pdf"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#abra.cwl",
            "baseCommand": [
                "java"
            ],
            "arguments": [
                {
                    "valueFrom": "/usr/bin/abra.jar",
                    "prefix": "-jar",
                    "position": 1,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-Xms$(Math.round(parseInt(runtime.ram)/1910))G",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-Xmx$(Math.floor(parseInt(runtime.ram)/1048) - 1)G",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "$(runtime.tmpdir)",
                    "position": 2,
                    "prefix": "--tmpdir",
                    "shellQuote": false
                }
            ],
            "requirements": [
                {
                    "dockerPull": "mskcc/roslin-variant-abra:2.17",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMin": "$(inputs.abra_ram_min)",
                    "coresMin": 16,
                    "class": "ResourceRequirement"
                }
            ],
            "doc": "None\n",
            "inputs": [
                {
                    "type": "int",
                    "id": "#abra.cwl/abra/abra_ram_min"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Set mapq for alignments that map equally well to reference and an ABRA generated contig. default of -1 disables (default - -1)",
                    "inputBinding": {
                        "prefix": "--amq",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/amq"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "bwa ref",
                    "inputBinding": {
                        "prefix": "--bwa-ref",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/bwa_ref"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Contig anchor [M_bases_at_contig_edge, max_mismatches_near_edge] (default - 10,2)",
                    "inputBinding": {
                        "prefix": "--ca",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/ca"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Compression level of output bam file (s) (default - 5)",
                    "inputBinding": {
                        "prefix": "--cl",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/cl"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Use positional consensus sequence when aligning high quality soft clipping",
                    "inputBinding": {
                        "prefix": "--cons",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/cons"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Optional file to which assembled contigs are written",
                    "inputBinding": {
                        "prefix": "--contigs",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/contigs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Max read move distance (default - 1000)",
                    "inputBinding": {
                        "prefix": "--dist",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/dist"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "If specified, use GKL Intel Deflater (experimental)",
                    "inputBinding": {
                        "prefix": "--gkl",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/gkl"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "GTF file defining exons and transcripts",
                    "inputBinding": {
                        "prefix": "--gtf",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/gtf"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "doc": "Required list of input sam or bam file (s) separated by comma",
                    "inputBinding": {
                        "itemSeparator": ",",
                        "prefix": "--in",
                        "position": 2
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#abra.cwl/abra/in"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "VCF containing known (or suspected) variant sites. Very large files should be avoided.",
                    "inputBinding": {
                        "prefix": "--in-vcf",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/in_vcf"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Enable BAM index generation when outputting sorted alignments (may require additonal memory)",
                    "inputBinding": {
                        "prefix": "--index",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/index"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Splice junctions definition file",
                    "inputBinding": {
                        "prefix": "--junctions",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/junctions"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Do not delete the temporary directory",
                    "inputBinding": {
                        "prefix": "--keep-tmp",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/keep_tmp"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Optional assembly kmer size(delimit with commas if multiple sizes specified)",
                    "inputBinding": {
                        "prefix": "--kmer",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/kmer"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Logging level (trace,debug,info,warn, error) (default - info)",
                    "inputBinding": {
                        "prefix": "--log",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/log"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Max assembled contigs (default - 64)",
                    "inputBinding": {
                        "prefix": "--mac",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/mac"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Regions with average depth exceeding this value will be downsampled (default - 1000)",
                    "inputBinding": {
                        "prefix": "--mad",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/mad"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Minimum mapping quality for a read to be used in assembly and be eligible for realignment (default - 20)",
                    "inputBinding": {
                        "prefix": "--mapq",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/mapq"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Maximum pre-pruned nodes in regional assembly (default - 150000)",
                    "inputBinding": {
                        "prefix": "--maxn",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/maxn"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Minimum base quality for inclusion in assembly. This value is compared against the sum of base qualities per kmer position (default - 20)",
                    "inputBinding": {
                        "prefix": "--mbq",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/mbq"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Assembly minimum contig length (default - -1)",
                    "inputBinding": {
                        "prefix": "--mcl",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/mcl"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Max number of cached reads per sample per thread (default - 1000000)",
                    "inputBinding": {
                        "prefix": "--mcr",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/mcr"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Min edge pruning ratio. Default value is appropriate for relatively sensitive somatic cases. May be increased for improved speed in germline only cases. (default - 0.01)",
                    "inputBinding": {
                        "prefix": "--mer",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/mer"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Max allowed mismatch rate when mapping reads back to contigs (default - 0.05)",
                    "inputBinding": {
                        "prefix": "--mmr",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/mmr"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Assembly minimum node frequency (default - 1)",
                    "inputBinding": {
                        "prefix": "--mnf",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/mnf"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Reads with noise score exceeding this value are not remapped. numMismatches+(numIndels*2) < readLength*mnr (default - 0.1)",
                    "inputBinding": {
                        "prefix": "--mrn",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/mrn"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Regions containing more reads than this value are not processed. Use -1 to disable. (default - 1000000)",
                    "inputBinding": {
                        "prefix": "--mrr",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/mrr"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Max reads to keep in memory per sample during the sort phase. When this value is exceeded, sort spills to disk (default - 1000000)",
                    "inputBinding": {
                        "prefix": "--msr",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/msr"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Do not attempt to sort final output",
                    "inputBinding": {
                        "prefix": "--nosort",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/nosort"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "doc": "Required list of output sam or bam file (s) separated by comma",
                    "inputBinding": {
                        "itemSeparator": ",",
                        "prefix": "--out",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/out"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Minimum read candidate fraction for triggering assembly (default - 0.01)",
                    "inputBinding": {
                        "prefix": "--rcf",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/rcf"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--ref",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/ref"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Skip assembly",
                    "inputBinding": {
                        "prefix": "--sa",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/sa"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Soft clip contig args [max_contigs, min_base_qual,frac_high_qual_bases, min_soft_clip_len] (default - 16,13,80,15)",
                    "inputBinding": {
                        "prefix": "--sc",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/sc"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Scoring used for contig alignments (match, mismatch_penalty, gap_open_penalty, gap_extend_penalty) (default - 8,32,48,1)",
                    "inputBinding": {
                        "prefix": "--sga",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/sga"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Input is single end",
                    "inputBinding": {
                        "prefix": "--single",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/single"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "If no target specified, skip realignment of chromosomes matching specified regex. Skipped reads are output without modification. Specify none to disable. (default - GL.*|hs37d5|chr.*random|chrUn. *|chrEBV|CMV|HBV|HCV.*|HIV. *|KSHV|HTLV.*|MCV|SV40|HPV.*)",
                    "inputBinding": {
                        "prefix": "--skip",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/skip"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Do not use observed indels in original alignments to generate contigs",
                    "inputBinding": {
                        "prefix": "--sobs",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/sobs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Skip usage of soft clipped sequences as putative contigs",
                    "inputBinding": {
                        "prefix": "--ssc",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/ssc"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Do not use unmapped reads anchored by mate to trigger assembly. These reads are still eligible to contribute to assembly",
                    "inputBinding": {
                        "prefix": "--sua",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/sua"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "BED-like file containing target regions with per region kmer sizes in 4th column",
                    "inputBinding": {
                        "prefix": "--target-kmers",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/target_kmers"
                },
                {
                    "type": [
                        "null",
                        "File",
                        "string"
                    ],
                    "doc": "BED file containing target regions",
                    "inputBinding": {
                        "prefix": "--targets",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/targets"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Number of threads (default - 16)",
                    "inputBinding": {
                        "prefix": "--threads",
                        "position": 2
                    },
                    "default": "16",
                    "id": "#abra.cwl/abra/threads"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Unset duplicate flag",
                    "inputBinding": {
                        "prefix": "--undup",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/undup"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Processing window size and overlap (size,overlap) (default - 400,200)",
                    "inputBinding": {
                        "prefix": "--ws",
                        "position": 2
                    },
                    "id": "#abra.cwl/abra/ws"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "${\n  return inputs.out;\n}\n"
                    },
                    "id": "#abra.cwl/abra/outbams"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "cmo_index"
            ],
            "label": "cmo-index",
            "requirements": [
                {
                    "dockerPull": "mskcc/roslin-variant-cmo-utils:1.9.15",
                    "class": "DockerRequirement"
                },
                {
                    "listing": [
                        "$(inputs.bam)"
                    ],
                    "class": "InitialWorkDirRequirement"
                },
                {
                    "ramMin": 16000,
                    "coresMin": 1,
                    "class": "ResourceRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--bam"
                    },
                    "id": "#cmo-index.cwl/bam"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.bam.basename)"
                    },
                    "secondaryFiles": [
                        "^.bai",
                        ".bai"
                    ],
                    "id": "#cmo-index.cwl/bam_indexed"
                }
            ],
            "id": "#cmo-index.cwl"
        },
        {
            "class": "CommandLineTool",
            "id": "#gatk.BaseRecalibrator.cwl",
            "baseCommand": [
                "java"
            ],
            "arguments": [
                {
                    "valueFrom": "/usr/bin/gatk.jar",
                    "prefix": "-jar",
                    "position": 1,
                    "shellQuote": false
                },
                {
                    "valueFrom": "BaseRecalibrator",
                    "prefix": "-T",
                    "position": 1,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-Xms$(Math.round(parseInt(runtime.ram)/1910))G",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-Xmx$(Math.floor(parseInt(runtime.ram)/1048) - 1)G",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-XX:-UseGCOverheadLimit",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-Djava.io.tmpdir=$(runtime.tmpdir)",
                    "position": 0,
                    "shellQuote": false
                }
            ],
            "requirements": [
                {
                    "dockerPull": "mskcc/roslin-variant-gatk:3.3-0",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMin": 24000,
                    "coresMin": 4,
                    "class": "ResourceRequirement"
                }
            ],
            "doc": "None\n",
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Input covariates table file for on-the-fly base quality score recalibration",
                    "inputBinding": {
                        "prefix": "--BQSR",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/BQSR"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Ignore warnings about base quality score encoding",
                    "inputBinding": {
                        "prefix": "--allow_potentially_misencoded_quality_scores",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/allow_potentially_misencoded_quality_scores"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Reads arguments from the specified file",
                    "inputBinding": {
                        "prefix": "--arg_file",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/arg_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Compression level to use for writing BAM files (0 - 9, higher is more compressed)",
                    "inputBinding": {
                        "prefix": "--bam_compression",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/bam_compression"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of BAQ calculation to apply in the engine (OFF| CALCULATE_AS_NECESSARY| RECALCULATE)",
                    "inputBinding": {
                        "prefix": "--baq",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/baq"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "BAQ gap open penalty",
                    "inputBinding": {
                        "prefix": "--baqGapOpenPenalty",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/baqGapOpenPenalty"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "the binary tag covariate name if using it",
                    "inputBinding": {
                        "prefix": "--binary_tag_name",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/binary_tag_name"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "BQSR BAQ gap open penalty (Phred Scaled). Default value is 40. 30 is perhaps better for whole genome call sets",
                    "inputBinding": {
                        "prefix": "--bqsrBAQGapOpenPenalty",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/bqsrBAQGapOpenPenalty"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string",
                        "inputBinding": {
                            "prefix": "--covariate"
                        }
                    },
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "One or more covariates to be used in the recalibration. Can be specified multiple times",
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/covariate"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Assign a default base quality",
                    "inputBinding": {
                        "prefix": "--defaultBaseQualities",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/defaultBaseQualities"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "default quality for the base deletions covariate",
                    "inputBinding": {
                        "prefix": "--deletions_default_quality",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/deletions_default_quality"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Turn off on-the-fly creation of",
                    "inputBinding": {
                        "prefix": "--disable_bam_indexing",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/disable_bam_indexing"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Disable printing of base insertion and deletion tags (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--disable_indel_quals",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/disable_indel_quals"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Target coverage threshold for downsampling to coverage",
                    "inputBinding": {
                        "prefix": "--downsample_to_coverage",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/downsample_to_coverage"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Fraction of reads to downsample to",
                    "inputBinding": {
                        "prefix": "--downsample_to_fraction",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/downsample_to_fraction"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of read downsampling to employ at a given locus (NONE|ALL_READS|BY_SAMPLE)",
                    "inputBinding": {
                        "prefix": "--downsampling_type",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/downsampling_type"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Emit the OQ tag with the original base qualities (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--emit_original_quals",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/emit_original_quals"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "One or more genomic intervals to exclude from processing",
                    "inputBinding": {
                        "prefix": "--excludeIntervals",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/excludeIntervals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "if a read has no stored bases (i.e. a '*'), filter out the read instead of blowing up.",
                    "inputBinding": {
                        "prefix": "--filter_bases_not_stored",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/filter_bases_not_stored"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "if a read has mismatching number of bases and base qualities, filter out the read instead of blowing up.",
                    "inputBinding": {
                        "prefix": "--filter_mismatching_base_and_quals",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/filter_mismatching_base_and_quals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "filter out reads with CIGAR containing the N operator, instead of stop processing and report an error.",
                    "inputBinding": {
                        "prefix": "--filter_reads_with_N_cigar",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/filter_reads_with_N_cigar"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Fix mis-encoded base quality scores",
                    "inputBinding": {
                        "prefix": "--fix_misencoded_quality_scores",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/fix_misencoded_quality_scores"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "GATK key file required to run with -et NO_ET",
                    "inputBinding": {
                        "prefix": "--gatk_key",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/gatk_key"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Enable on-the-fly creation of",
                    "inputBinding": {
                        "prefix": "--generate_md5",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/generate_md5"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Global Qscore Bayesian prior to use for BQSR",
                    "inputBinding": {
                        "prefix": "--globalQScorePrior",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/globalQScorePrior"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Size of the k-mer context to be used for base insertions and deletions",
                    "inputBinding": {
                        "prefix": "--indels_context_size",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/indels_context_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File",
                            "inputBinding": {
                                "prefix": "--input_file"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "Input file containing sequence data (SAM or BAM)",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/input_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "default quality for the base insertions covariate",
                    "inputBinding": {
                        "prefix": "--insertions_default_quality",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/insertions_default_quality"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Interval merging rule for abutting intervals (ALL| OVERLAPPING_ONLY)",
                    "inputBinding": {
                        "prefix": "--interval_merging",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/interval_merging"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Amount of padding (in bp) to add to each interval",
                    "inputBinding": {
                        "prefix": "--interval_padding",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/interval_padding"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set merging approach to use for combining interval inputs (UNION|INTERSECTION)",
                    "inputBinding": {
                        "prefix": "--interval_set_rule",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/interval_set_rule"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "One or more genomic intervals over which to operate",
                    "inputBinding": {
                        "prefix": "--intervals",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/intervals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Keep program records in the SAM header",
                    "inputBinding": {
                        "prefix": "--keep_program_records",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/keep_program_records"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File",
                        "inputBinding": {
                            "prefix": "--knownSites"
                        }
                    },
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "A database of known polymorphic sites to skip over in the recalibration algorithm",
                    "secondaryFiles": [
                        ".idx"
                    ],
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/knownSites"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "List the available covariates and exit",
                    "inputBinding": {
                        "prefix": "--list",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/list"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set the logging location",
                    "inputBinding": {
                        "prefix": "--log_to_file",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/log_to_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set the minimum level of logging",
                    "inputBinding": {
                        "prefix": "--logging_level",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/logging_level"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Reduce memory usage in multi-threaded code at the expense of threading efficiency",
                    "inputBinding": {
                        "prefix": "--lowMemoryMode",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/lowMemoryMode"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "minimum quality for the bases in the tail of the reads to be considered",
                    "inputBinding": {
                        "prefix": "--low_quality_tail",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/low_quality_tail"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Stop execution cleanly as soon as maxRuntime has been reached",
                    "inputBinding": {
                        "prefix": "--maxRuntime",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/maxRuntime"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Unit of time used by maxRuntime (NANOSECONDS|MICROSECONDS| MILLISECONDS|SECONDS|MINUTES| HOURS|DAYS)",
                    "inputBinding": {
                        "prefix": "--maxRuntimeUnits",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/maxRuntimeUnits"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "The maximum cycle value permitted for the Cycle covariate",
                    "inputBinding": {
                        "prefix": "--maximum_cycle_value",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/maximum_cycle_value"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Size of the k-mer context to be used for base mismatches",
                    "inputBinding": {
                        "prefix": "--mismatches_context_size",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/mismatches_context_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "default quality for the base mismatches covariate",
                    "inputBinding": {
                        "prefix": "--mismatches_default_quality",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/mismatches_default_quality"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Enable threading efficiency monitoring",
                    "inputBinding": {
                        "prefix": "--monitorThreadEfficiency",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/monitorThreadEfficiency"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Always output all the records in VCF FORMAT fields, even if some are missing",
                    "inputBinding": {
                        "prefix": "--never_trim_vcf_format_field",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/never_trim_vcf_format_field"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Do not use the standard set of covariates, but rather just the ones listed using the -cov argumentthout_dbsnp_potentially_ruining_quality,--run_without_dbsnp_potentially_ruining_quality If specified, allows the recalibrator to be used without a dbsnp rod. Very unsafe and for expert users only.",
                    "inputBinding": {
                        "prefix": "--no_standard_covs",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/no_standard_covs"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Use a non-deterministic random seed",
                    "inputBinding": {
                        "prefix": "--nonDeterministicRandomSeed",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/nonDeterministicRandomSeed"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Total number of BAM file handles to keep open simultaneously",
                    "inputBinding": {
                        "prefix": "--num_bam_file_handles",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/num_bam_file_handles"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "8",
                    "doc": "Number of CPU threads to allocate per data thread",
                    "inputBinding": {
                        "prefix": "--num_cpu_threads_per_data_thread",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/num_cpu_threads_per_data_thread"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Number of data threads to allocate to this analysis",
                    "inputBinding": {
                        "prefix": "--num_threads",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/num_threads"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "The output recalibration table file to create",
                    "inputBinding": {
                        "prefix": "--out",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/out"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Pedigree files for samples",
                    "inputBinding": {
                        "prefix": "--pedigree",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/pedigree"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Pedigree string for samples",
                    "inputBinding": {
                        "prefix": "--pedigreeString",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/pedigreeString"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Validation strictness for pedigree information (STRICT| SILENT)",
                    "inputBinding": {
                        "prefix": "--pedigreeValidationType",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/pedigreeValidationType"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Write GATK runtime performance log to this file",
                    "inputBinding": {
                        "prefix": "--performanceLog",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/performanceLog"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Run reporting mode (NO_ET|AWS|STDOUT)",
                    "inputBinding": {
                        "prefix": "--phone_home",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/phone_home"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Don't recalibrate bases with quality scores less than this threshold (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--preserve_qscores_less_than",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/preserve_qscores_less_than"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "number of distinct quality scores in the quantized output",
                    "inputBinding": {
                        "prefix": "--quantizing_levels",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/quantizing_levels"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Number of reads per SAM file to buffer in memory",
                    "inputBinding": {
                        "prefix": "--read_buffer_size",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/read_buffer_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Filters to apply to reads before analysis",
                    "inputBinding": {
                        "prefix": "--read_filter",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/read_filter"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Exclude read groups based on tags",
                    "inputBinding": {
                        "prefix": "--read_group_black_list",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/read_group_black_list"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "refactor cigar string with NDN elements to one element",
                    "inputBinding": {
                        "prefix": "--refactor_NDN_cigar_string",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/refactor_NDN_cigar_string"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa",
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "--reference_sequence",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/reference_sequence"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Remove program records from the SAM header",
                    "inputBinding": {
                        "prefix": "--remove_program_records",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/remove_program_records"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Rename sample IDs on-the-fly at runtime using the provided mapping file",
                    "inputBinding": {
                        "prefix": "--sample_rename_mapping_file",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/sample_rename_mapping_file"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "If provided, output BAM files will be simplified to include just key reads for downstream variation discovery analyses (removing duplicates, PF-, non-primary reads), as well stripping all extended tags from the kept reads except the read group identifier",
                    "inputBinding": {
                        "prefix": "--simplifyBAM",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/simplifyBAM"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Just output sites without genotypes (i.e. only the first 8 columns of the VCF)",
                    "inputBinding": {
                        "prefix": "--sites_only",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/sites_only"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Defines the behavior of the recalibrator when it encounters no calls in the color space. Options = THROW_EXCEPTION, LEAVE_READ_UNRECALIBRATED, or PURGE_READ (THROW_EXCEPTION| LEAVE_READ_UNRECALIBRATED| PURGE_READ)",
                    "inputBinding": {
                        "prefix": "--solid_nocall_strategy",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/solid_nocall_strategy"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "How should we recalibrate solid bases in which the reference was inserted? Options = DO_NOTHING, SET_Q_ZERO, SET_Q_ZERO_BASE_N, or REMOVE_REF_BIAS (DO_NOTHING| SET_Q_ZERO|SET_Q_ZERO_BASE_N| REMOVE_REF_BIAS)",
                    "inputBinding": {
                        "prefix": "--solid_recal_mode",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/solid_recal_mode"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Sort the rows in the tables of reports",
                    "inputBinding": {
                        "prefix": "--sort_by_all_columns",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/sort_by_all_columns"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Tag to identify this GATK run as part of a group of runs",
                    "inputBinding": {
                        "prefix": "--tag",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/tag"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Enable unsafe operations - nothing will be checked at runtime (ALLOW_N_CIGAR_READS| ALLOW_UNINDEXED_BAM| ALLOW_UNSET_BAM_SORT_ORDER| NO_READ_ORDER_VERIFICATION| ALLOW_SEQ_DICT_INCOMPATIBILITY| LENIENT_VCF_PROCESSING|ALL)",
                    "inputBinding": {
                        "prefix": "--unsafe",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/unsafe"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Use the base quality scores from the OQ tag",
                    "inputBinding": {
                        "prefix": "--useOriginalQualities",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/useOriginalQualities"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "How strict should we be with validation (STRICT|LENIENT| SILENT)",
                    "inputBinding": {
                        "prefix": "--validation_strictness",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/validation_strictness"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Parameter to pass to the VCF/BCF IndexCreator",
                    "inputBinding": {
                        "prefix": "--variant_index_parameter",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/variant_index_parameter"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of IndexCreator to use for VCF/BCF indices (DYNAMIC_SEEK| DYNAMIC_SIZE|LINEAR|INTERVAL)",
                    "inputBinding": {
                        "prefix": "--variant_index_type",
                        "position": 2
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/variant_index_type"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${\n  if (inputs.out)\n    return inputs.out;\n  return null;\n}\n"
                    },
                    "id": "#gatk.BaseRecalibrator.cwl/gatk-BaseRecalibrator/recal_matrix"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#gatk.FindCoveredIntervals.cwl",
            "baseCommand": [
                "java"
            ],
            "arguments": [
                {
                    "valueFrom": "/usr/bin/gatk.jar",
                    "prefix": "-jar",
                    "position": 1,
                    "shellQuote": false
                },
                {
                    "valueFrom": "FindCoveredIntervals",
                    "prefix": "-T",
                    "position": 1,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-Xms$(Math.round(parseInt(runtime.ram)/1910))G",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-Xmx$(Math.floor(parseInt(runtime.ram)/1048) - 1)G",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-XX:-UseGCOverheadLimit",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-Djava.io.tmpdir=$(runtime.tmpdir)",
                    "position": 0,
                    "shellQuote": false
                }
            ],
            "requirements": [
                {
                    "dockerPull": "mskcc/roslin-variant-gatk:3.3-0",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMin": 24000,
                    "coresMin": 2,
                    "class": "ResourceRequirement"
                }
            ],
            "doc": "None\n",
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Input covariates table file for on-the-fly base quality score recalibration",
                    "inputBinding": {
                        "prefix": "--BQSR",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/BQSR"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Threshold for the probability of a profile state being active.",
                    "inputBinding": {
                        "prefix": "--activeProbabilityThreshold",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/activeProbabilityThreshold"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "The active region extension; if not provided defaults to Walker annotated default",
                    "inputBinding": {
                        "prefix": "--activeRegionExtension",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/activeRegionExtension"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Use this interval list file as the active regions to process",
                    "inputBinding": {
                        "prefix": "--activeRegionIn",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/activeRegionIn"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "The active region maximum size; if not provided defaults to Walker annotated default",
                    "inputBinding": {
                        "prefix": "--activeRegionMaxSize",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/activeRegionMaxSize"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Output the active region to this IGV formatted file",
                    "inputBinding": {
                        "prefix": "--activeRegionOut",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/activeRegionOut"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Output the raw activity profile results in IGV format",
                    "inputBinding": {
                        "prefix": "--activityProfileOut",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/activityProfileOut"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Ignore warnings about base quality score encoding",
                    "inputBinding": {
                        "prefix": "--allow_potentially_misencoded_quality_scores",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/allow_potentially_misencoded_quality_scores"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Reads arguments from the specified file",
                    "inputBinding": {
                        "prefix": "--arg_file",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/arg_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Compression level to use for writing BAM files (0 - 9, higher is more compressed)",
                    "inputBinding": {
                        "prefix": "--bam_compression",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/bam_compression"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "The sigma of the band pass filter Gaussian kernel; if not provided defaults to Walker annotated default",
                    "inputBinding": {
                        "prefix": "--bandPassSigma",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/bandPassSigma"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of BAQ calculation to apply in the engine (OFF| CALCULATE_AS_NECESSARY| RECALCULATE)",
                    "inputBinding": {
                        "prefix": "--baq",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/baq"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "BAQ gap open penalty",
                    "inputBinding": {
                        "prefix": "--baqGapOpenPenalty",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/baqGapOpenPenalty"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "The minimum allowable coverage to be considered covered",
                    "inputBinding": {
                        "prefix": "--coverage_threshold",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/coverage_threshold"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Assign a default base quality",
                    "inputBinding": {
                        "prefix": "--defaultBaseQualities",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/defaultBaseQualities"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Turn off on-the-fly creation of",
                    "inputBinding": {
                        "prefix": "--disable_bam_indexing",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/disable_bam_indexing"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Disable printing of base insertion and deletion tags (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--disable_indel_quals",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/disable_indel_quals"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Target coverage threshold for downsampling to coverage",
                    "inputBinding": {
                        "prefix": "--downsample_to_coverage",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/downsample_to_coverage"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Fraction of reads to downsample to",
                    "inputBinding": {
                        "prefix": "--downsample_to_fraction",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/downsample_to_fraction"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of read downsampling to employ at a given locus (NONE| ALL_READS|BY_SAMPLE)",
                    "inputBinding": {
                        "prefix": "--downsampling_type",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/downsampling_type"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Emit the OQ tag with the original base qualities (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--emit_original_quals",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/emit_original_quals"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "One or more genomic intervals to exclude from processing",
                    "inputBinding": {
                        "prefix": "--excludeIntervals",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/excludeIntervals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "if a read has no stored bases (i.e. a '*'), filter out the read instead of blowing up.",
                    "inputBinding": {
                        "prefix": "--filter_bases_not_stored",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/filter_bases_not_stored"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "if a read has mismatching number of bases and base qualities, filter out the read instead of blowing up.",
                    "inputBinding": {
                        "prefix": "--filter_mismatching_base_and_quals",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/filter_mismatching_base_and_quals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "filter out reads with CIGAR containing the N operator, instead of stop processing and report an error.",
                    "inputBinding": {
                        "prefix": "--filter_reads_with_N_cigar",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/filter_reads_with_N_cigar"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Fix mis-encoded base quality scores",
                    "inputBinding": {
                        "prefix": "--fix_misencoded_quality_scores",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/fix_misencoded_quality_scores"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "If provided, all bases will be tagged as active",
                    "inputBinding": {
                        "prefix": "--forceActive",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/forceActive"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "GATK key file required to run with -et NO_ET",
                    "inputBinding": {
                        "prefix": "--gatk_key",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/gatk_key"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Enable on-the-fly creation of",
                    "inputBinding": {
                        "prefix": "--generate_md5",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/generate_md5"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Global Qscore Bayesian prior to use for BQSR",
                    "inputBinding": {
                        "prefix": "--globalQScorePrior",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/globalQScorePrior"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File",
                        "inputBinding": {
                            "prefix": "--input_file"
                        }
                    },
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "Input file containing sequence data (SAM or BAM)",
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/input_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Interval merging rule for abutting intervals (ALL| OVERLAPPING_ONLY)",
                    "inputBinding": {
                        "prefix": "--interval_merging",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/interval_merging"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Amount of padding (in bp) to add to each interval",
                    "inputBinding": {
                        "prefix": "--interval_padding",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/interval_padding"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set merging approach to use for combining interval inputs (UNION|INTERSECTION)",
                    "inputBinding": {
                        "prefix": "--interval_set_rule",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/interval_set_rule"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string",
                        "inputBinding": {
                            "prefix": "--intervals",
                            "separate": true
                        }
                    },
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "One or more genomic intervals over which to operate",
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/intervals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Keep program records in the SAM header",
                    "inputBinding": {
                        "prefix": "--keep_program_records",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/keep_program_records"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set the logging location",
                    "inputBinding": {
                        "prefix": "--log_to_file",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/log_to_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set the minimum level of logging",
                    "inputBinding": {
                        "prefix": "--logging_level",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/logging_level"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Stop execution cleanly as soon as maxRuntime has been reached",
                    "inputBinding": {
                        "prefix": "--maxRuntime",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/maxRuntime"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Unit of time used by maxRuntime (NANOSECONDS|MICROSECONDS| MILLISECONDS|SECONDS|MINUTES| HOURS|DAYS)",
                    "inputBinding": {
                        "prefix": "--maxRuntimeUnits",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/maxRuntimeUnits"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "The minimum allowable base quality score to be counted for coverage",
                    "inputBinding": {
                        "prefix": "--minBaseQuality",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/minBaseQuality"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "The minimum allowable mapping quality score to be counted for coverage",
                    "inputBinding": {
                        "prefix": "--minMappingQuality",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/minMappingQuality"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Enable threading efficiency monitoring",
                    "inputBinding": {
                        "prefix": "--monitorThreadEfficiency",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/monitorThreadEfficiency"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Always output all the records in VCF FORMAT fields, even if some are missing",
                    "inputBinding": {
                        "prefix": "--never_trim_vcf_format_field",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/never_trim_vcf_format_field"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Use a non-deterministic random seed",
                    "inputBinding": {
                        "prefix": "--nonDeterministicRandomSeed",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/nonDeterministicRandomSeed"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Total number of BAM file handles to keep open simultaneously",
                    "inputBinding": {
                        "prefix": "--num_bam_file_handles",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/num_bam_file_handles"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Number of CPU threads to allocate per data thread",
                    "inputBinding": {
                        "prefix": "--num_cpu_threads_per_data_thread",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/num_cpu_threads_per_data_thread"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Number of data threads to allocate to this analysis",
                    "inputBinding": {
                        "prefix": "--num_threads",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/num_threads"
                },
                {
                    "type": "string",
                    "doc": "An output file created by the walker. Will overwrite contents if file exists",
                    "inputBinding": {
                        "prefix": "--out",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/out"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Pedigree files for samples",
                    "inputBinding": {
                        "prefix": "--pedigree",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/pedigree"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Pedigree string for samples",
                    "inputBinding": {
                        "prefix": "--pedigreeString",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/pedigreeString"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Validation strictness for pedigree information (STRICT| SILENT)",
                    "inputBinding": {
                        "prefix": "--pedigreeValidationType",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/pedigreeValidationType"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Write GATK runtime performance log to this file",
                    "inputBinding": {
                        "prefix": "--performanceLog",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/performanceLog"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Run reporting mode (NO_ET|AWS| STDOUT)",
                    "inputBinding": {
                        "prefix": "--phone_home",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/phone_home"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Don't recalibrate bases with quality scores less than this threshold (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--preserve_qscores_less_than",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/preserve_qscores_less_than"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Number of reads per SAM file to buffer in memory",
                    "inputBinding": {
                        "prefix": "--read_buffer_size",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/read_buffer_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Filters to apply to reads before analysis",
                    "inputBinding": {
                        "prefix": "--read_filter",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/read_filter"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Exclude read groups based on tags",
                    "inputBinding": {
                        "prefix": "--read_group_black_list",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/read_group_black_list"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "refactor cigar string with NDN elements to one element",
                    "inputBinding": {
                        "prefix": "--refactor_NDN_cigar_string",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/refactor_NDN_cigar_string"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa",
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "--reference_sequence",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/reference_sequence"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Remove program records from the SAM header",
                    "inputBinding": {
                        "prefix": "--remove_program_records",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/remove_program_records"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Rename sample IDs on-the-fly at runtime using the provided mapping file",
                    "inputBinding": {
                        "prefix": "--sample_rename_mapping_file",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/sample_rename_mapping_file"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "If provided, output BAM files will be simplified to include just key reads for downstream variation discovery analyses (removing duplicates, PF-, non-primary reads), as well stripping all extended tags from the kept reads except the read group identifier",
                    "inputBinding": {
                        "prefix": "--simplifyBAM",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/simplifyBAM"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Just output sites without genotypes (i.e. only the first 8 columns of the VCF)",
                    "inputBinding": {
                        "prefix": "--sites_only",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/sites_only"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Tag to identify this GATK run as part of a group of runs",
                    "inputBinding": {
                        "prefix": "--tag",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/tag"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "output intervals that fail the coverage threshold instead",
                    "inputBinding": {
                        "prefix": "--uncovered",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/uncovered"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Enable unsafe operations - nothing will be checked at runtime (ALLOW_N_CIGAR_READS| ALLOW_UNINDEXED_BAM| ALLOW_UNSET_BAM_SORT_ORDER| NO_READ_ORDER_VERIFICATION| ALLOW_SEQ_DICT_INCOMPATIBILITY| LENIENT_VCF_PROCESSING|ALL)",
                    "inputBinding": {
                        "prefix": "--unsafe",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/unsafe"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Use the base quality scores from the OQ tag",
                    "inputBinding": {
                        "prefix": "--useOriginalQualities",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/useOriginalQualities"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "How strict should we be with validation (STRICT|LENIENT| SILENT)",
                    "inputBinding": {
                        "prefix": "--validation_strictness",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/validation_strictness"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Parameter to pass to the VCF/BCF IndexCreator",
                    "inputBinding": {
                        "prefix": "--variant_index_parameter",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/variant_index_parameter"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of IndexCreator to use for VCF/BCF indices (DYNAMIC_SEEK| DYNAMIC_SIZE|LINEAR|INTERVAL)",
                    "inputBinding": {
                        "prefix": "--variant_index_type",
                        "position": 2
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/variant_index_type"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${\n  if (inputs.out)\n    return inputs.out;\n  return null;\n}\n"
                    },
                    "id": "#gatk.FindCoveredIntervals.cwl/gatk-FindCoveredIntervals/fci_list"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#gatk.PrintReads.cwl",
            "baseCommand": [
                "java"
            ],
            "arguments": [
                {
                    "valueFrom": "/usr/bin/gatk.jar",
                    "prefix": "-jar",
                    "position": 1,
                    "shellQuote": false
                },
                {
                    "valueFrom": "PrintReads",
                    "prefix": "-T",
                    "position": 1,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-Xms$(Math.round(parseInt(runtime.ram)/1910))G",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-Xmx$(Math.floor(parseInt(runtime.ram)/1048) - 1)G",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-XX:-UseGCOverheadLimit",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-Djava.io.tmpdir=$(runtime.tmpdir)",
                    "position": 0,
                    "shellQuote": false
                }
            ],
            "requirements": [
                {
                    "dockerPull": "mskcc/roslin-variant-gatk:3.3-0",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMin": 36000,
                    "coresMin": 2,
                    "class": "ResourceRequirement"
                }
            ],
            "doc": "None\n",
            "inputs": [
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "doc": "Input covariates table file for on-the-fly base quality score recalibration",
                    "inputBinding": {
                        "prefix": "--BQSR",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/BQSR"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Ignore warnings about base quality score encoding",
                    "inputBinding": {
                        "prefix": "--allow_potentially_misencoded_quality_scores",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/allow_potentially_misencoded_quality_scores"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Reads arguments from the specified file",
                    "inputBinding": {
                        "prefix": "--arg_file",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/arg_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Compression level to use for writing BAM files (0 - 9, higher is more compressed)",
                    "inputBinding": {
                        "prefix": "--bam_compression",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/bam_compression"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of BAQ calculation to apply in the engine (OFF| CALCULATE_AS_NECESSARY| RECALCULATE)",
                    "inputBinding": {
                        "prefix": "--baq",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/baq"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "BAQ gap open penalty",
                    "inputBinding": {
                        "prefix": "--baqGapOpenPenalty",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/baqGapOpenPenalty"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Assign a default base quality",
                    "inputBinding": {
                        "prefix": "--defaultBaseQualities",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/defaultBaseQualities"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Turn off on-the-fly creation of",
                    "inputBinding": {
                        "prefix": "--disable_bam_indexing",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/disable_bam_indexing"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Disable printing of base insertion and deletion tags (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--disable_indel_quals",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/disable_indel_quals"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Target coverage threshold for downsampling to coverage",
                    "inputBinding": {
                        "prefix": "--downsample_to_coverage",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/downsample_to_coverage"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Fraction of reads to downsample to",
                    "inputBinding": {
                        "prefix": "--downsample_to_fraction",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/downsample_to_fraction"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of read downsampling to employ at a given locus (NONE| ALL_READS|BY_SAMPLE)",
                    "inputBinding": {
                        "prefix": "--downsampling_type",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/downsampling_type"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Emit the OQ tag with the original base qualities (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--emit_original_quals",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/emit_original_quals"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "One or more genomic intervals to exclude from processing",
                    "inputBinding": {
                        "prefix": "--excludeIntervals",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/excludeIntervals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "if a read has no stored bases (i.e. a '*'), filter out the read instead of blowing up.",
                    "inputBinding": {
                        "prefix": "--filter_bases_not_stored",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/filter_bases_not_stored"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "if a read has mismatching number of bases and base qualities, filter out the read instead of blowing up.",
                    "inputBinding": {
                        "prefix": "--filter_mismatching_base_and_quals",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/filter_mismatching_base_and_quals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "filter out reads with CIGAR containing the N operator, instead of stop processing and report an error.",
                    "inputBinding": {
                        "prefix": "--filter_reads_with_N_cigar",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/filter_reads_with_N_cigar"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Fix mis-encoded base quality scores",
                    "inputBinding": {
                        "prefix": "--fix_misencoded_quality_scores",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/fix_misencoded_quality_scores"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "GATK key file required to run with -et NO_ET",
                    "inputBinding": {
                        "prefix": "--gatk_key",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/gatk_key"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Enable on-the-fly creation of",
                    "inputBinding": {
                        "prefix": "--generate_md5",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/generate_md5"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Global Qscore Bayesian prior to use for BQSR",
                    "inputBinding": {
                        "prefix": "--globalQScorePrior",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/globalQScorePrior"
                },
                {
                    "type": "File",
                    "doc": "Input file containing sequence data (SAM or BAM)",
                    "inputBinding": {
                        "prefix": "--input_file",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/input_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Interval merging rule for abutting intervals (ALL| OVERLAPPING_ONLY)",
                    "inputBinding": {
                        "prefix": "--interval_merging",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/interval_merging"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Amount of padding (in bp) to add to each interval",
                    "inputBinding": {
                        "prefix": "--interval_padding",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/interval_padding"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set merging approach to use for combining interval inputs (UNION|INTERSECTION)",
                    "inputBinding": {
                        "prefix": "--interval_set_rule",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/interval_set_rule"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "One or more genomic intervals over which to operate",
                    "inputBinding": {
                        "prefix": "--intervals",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/intervals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Keep program records in the SAM header",
                    "inputBinding": {
                        "prefix": "--keep_program_records",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/keep_program_records"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set the logging location",
                    "inputBinding": {
                        "prefix": "--log_to_file",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/log_to_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Set the minimum level of logging",
                    "inputBinding": {
                        "prefix": "--logging_level",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/logging_level"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Stop execution cleanly as soon as maxRuntime has been reached",
                    "inputBinding": {
                        "prefix": "--maxRuntime",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/maxRuntime"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Unit of time used by maxRuntime (NANOSECONDS|MICROSECONDS| MILLISECONDS|SECONDS|MINUTES| HOURS|DAYS)",
                    "inputBinding": {
                        "prefix": "--maxRuntimeUnits",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/maxRuntimeUnits"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Enable threading efficiency monitoring",
                    "inputBinding": {
                        "prefix": "--monitorThreadEfficiency",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/monitorThreadEfficiency"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Always output all the records in VCF FORMAT fields, even if some are missing",
                    "inputBinding": {
                        "prefix": "--never_trim_vcf_format_field",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/never_trim_vcf_format_field"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Use a non-deterministic random seed",
                    "inputBinding": {
                        "prefix": "--nonDeterministicRandomSeed",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/nonDeterministicRandomSeed"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Total number of BAM file handles to keep open simultaneously",
                    "inputBinding": {
                        "prefix": "--num_bam_file_handles",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/num_bam_file_handles"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "2",
                    "doc": "Number of CPU threads to allocate per data thread",
                    "inputBinding": {
                        "prefix": "--num_cpu_threads_per_data_thread",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/num_cpu_threads_per_data_thread"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Number of data threads to allocate to this analysis",
                    "inputBinding": {
                        "prefix": "--num_threads",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/num_threads"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Print the first n reads from the file, discarding the rest",
                    "inputBinding": {
                        "prefix": "--number",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/number"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Write output to this BAM filename instead of STDOUT",
                    "inputBinding": {
                        "prefix": "--out",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/out"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Pedigree files for samples",
                    "inputBinding": {
                        "prefix": "--pedigree",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/pedigree"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Pedigree string for samples",
                    "inputBinding": {
                        "prefix": "--pedigreeString",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/pedigreeString"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Validation strictness for pedigree information (STRICT| SILENT)",
                    "inputBinding": {
                        "prefix": "--pedigreeValidationType",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/pedigreeValidationType"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Write GATK runtime performance log to this file",
                    "inputBinding": {
                        "prefix": "--performanceLog",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/performanceLog"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Run reporting mode (NO_ET|AWS| STDOUT)",
                    "inputBinding": {
                        "prefix": "--phone_home",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/phone_home"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Exclude all reads with this platform from the output",
                    "inputBinding": {
                        "prefix": "--platform",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/platform"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Don't recalibrate bases with quality scores less than this threshold (with -BQSR)",
                    "inputBinding": {
                        "prefix": "--preserve_qscores_less_than",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/preserve_qscores_less_than"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Exclude all reads with this read group from the output",
                    "inputBinding": {
                        "prefix": "--readGroup",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/readGroup"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Number of reads per SAM file to buffer in memory",
                    "inputBinding": {
                        "prefix": "--read_buffer_size",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/read_buffer_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Filters to apply to reads before analysis",
                    "inputBinding": {
                        "prefix": "--read_filter",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/read_filter"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Exclude read groups based on tags",
                    "inputBinding": {
                        "prefix": "--read_group_black_list",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/read_group_black_list"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "refactor cigar string with NDN elements to one element",
                    "inputBinding": {
                        "prefix": "--refactor_NDN_cigar_string",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/refactor_NDN_cigar_string"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa",
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "--reference_sequence",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/reference_sequence"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Remove program records from the SAM header",
                    "inputBinding": {
                        "prefix": "--remove_program_records",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/remove_program_records"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "File containing a list of samples (one per line). Can be specified multiple times",
                    "inputBinding": {
                        "prefix": "--sample_file",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/sample_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Sample name to be included in the analysis. Can be specified multiple times.",
                    "inputBinding": {
                        "prefix": "--sample_name",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/sample_name"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Rename sample IDs on-the-fly at runtime using the provided mapping file",
                    "inputBinding": {
                        "prefix": "--sample_rename_mapping_file",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/sample_rename_mapping_file"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Simplify all reads.",
                    "inputBinding": {
                        "prefix": "--simplify",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/simplify"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "If provided, output BAM files will be simplified to include just key reads for downstream variation discovery analyses (removing duplicates, PF-, non-primary reads), as well stripping all extended tags from the kept reads except the read group identifier",
                    "inputBinding": {
                        "prefix": "--simplifyBAM",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/simplifyBAM"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Just output sites without genotypes (i.e. only the first 8 columns of the VCF)",
                    "inputBinding": {
                        "prefix": "--sites_only",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/sites_only"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Tag to identify this GATK run as part of a group of runs",
                    "inputBinding": {
                        "prefix": "--tag",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/tag"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Enable unsafe operations - nothing will be checked at runtime (ALLOW_N_CIGAR_READS| ALLOW_UNINDEXED_BAM| ALLOW_UNSET_BAM_SORT_ORDER| NO_READ_ORDER_VERIFICATION| ALLOW_SEQ_DICT_INCOMPATIBILITY| LENIENT_VCF_PROCESSING|ALL)",
                    "inputBinding": {
                        "prefix": "--unsafe",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/unsafe"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "doc": "Use the base quality scores from the OQ tag",
                    "inputBinding": {
                        "prefix": "--useOriginalQualities",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/useOriginalQualities"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "How strict should we be with validation (STRICT|LENIENT| SILENT)",
                    "inputBinding": {
                        "prefix": "--validation_strictness",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/validation_strictness"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Parameter to pass to the VCF/BCF IndexCreator",
                    "inputBinding": {
                        "prefix": "--variant_index_parameter",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/variant_index_parameter"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "Type of IndexCreator to use for VCF/BCF indices (DYNAMIC_SEEK| DYNAMIC_SIZE|LINEAR|INTERVAL)",
                    "inputBinding": {
                        "prefix": "--variant_index_type",
                        "position": 2
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/variant_index_type"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "outputBinding": {
                        "glob": "${\n  if (inputs.out)\n    return inputs.out;\n  return null;\n}\n"
                    },
                    "id": "#gatk.PrintReads.cwl/gatk-PrintReads/out_bam"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#list2bed.cwl",
            "baseCommand": [
                "python",
                "/usr/bin/list2bed.py"
            ],
            "requirements": [
                {
                    "dockerPull": "mskcc/roslin-variant-list2bed:1.0.1",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMin": 2000,
                    "coresMin": 1,
                    "class": "ResourceRequirement"
                }
            ],
            "doc": "Convert a Picard interval list file to a UCSC BED format\n",
            "inputs": [
                {
                    "type": [
                        "string",
                        "File",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "doc": "picard interval list",
                    "inputBinding": {
                        "prefix": "--input_file"
                    },
                    "id": "#list2bed.cwl/list2bed/input_file"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": true,
                    "doc": "sort bed file output",
                    "inputBinding": {
                        "prefix": "--no_sort"
                    },
                    "id": "#list2bed.cwl/list2bed/no_sort"
                },
                {
                    "type": "string",
                    "doc": "output bed file",
                    "inputBinding": {
                        "prefix": "--output_file"
                    },
                    "id": "#list2bed.cwl/list2bed/output_filename"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${\n  if (inputs.output_filename)\n    return inputs.output_filename;\n  return null;\n}\n"
                    },
                    "id": "#list2bed.cwl/list2bed/output_file"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#picard.CollectMultipleMetrics.cwl",
            "baseCommand": [
                "java"
            ],
            "arguments": [
                {
                    "valueFrom": "/usr/bin/picard-tools/picard.jar",
                    "prefix": "-jar",
                    "position": 1,
                    "shellQuote": false
                },
                {
                    "valueFrom": "CollectMultipleMetrics",
                    "position": 1,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-Xms$(Math.round(parseInt(runtime.ram)/1910))G",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-Xmx$(Math.floor(parseInt(runtime.ram)/1048) - 1)G",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-XX:-UseGCOverheadLimit",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "-Djava.io.tmpdir=$(runtime.tmpdir)",
                    "position": 0,
                    "shellQuote": false
                },
                {
                    "valueFrom": "TMP_DIR=$(runtime.tmpdir)",
                    "position": 2,
                    "shellQuote": false
                }
            ],
            "requirements": [
                {
                    "dockerPull": "mskcc/roslin-variant-picard:2.9",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "ramMin": 16000,
                    "coresMin": 1,
                    "class": "ResourceRequirement"
                }
            ],
            "doc": "None\n",
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "doc": "If true (default), then the sort order in the header file will be ignored. Default value - true. This option can be set to 'null' to clear the default value. Possible values - {true, false}",
                    "inputBinding": {
                        "prefix": "ASSUME_SORTED=True",
                        "separate": false,
                        "position": 2
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/AS"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "COMPRESSION_LEVEL=",
                        "position": 2,
                        "separate": false
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/COMPRESSION_LEVEL"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "prefix": "CREATE_INDEX=True",
                        "position": 2
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/CREATE_INDEX"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "prefix": "CREATE_MD5_FILE=True",
                        "position": 2
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/CREATE_MD5_FILE"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "VCF format dbSNP file, used to exclude regions around known polymorphisms from analysis by some PROGRAMs; PROGRAMs whose CLP doesn't allow for this argument will quietly ignore it. Default value - null.",
                    "inputBinding": {
                        "prefix": "DB_SNP=",
                        "position": 2,
                        "separate": false
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/DB_SNP"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Append the given file extension to all metric file names (ex. OUTPUT.insert_size_metrics.EXT). None if null Default value - null.",
                    "inputBinding": {
                        "prefix": "FILE_EXTENSION=",
                        "position": 2,
                        "separate": false
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/EXT"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "I=",
                        "position": 2,
                        "separate": false
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/I"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "An optional list of intervals to restrict analysis to. Only pertains to some of the PROGRAMs. Programs whose stand-alone CLP does not have an INTERVALS argument will silently ignore this argument. Default value - null.",
                    "inputBinding": {
                        "prefix": "INTERVALS=",
                        "position": 2,
                        "separate": false
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/INTERVALS"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "MAX_RECORDS_IN_RAM=",
                        "position": 2,
                        "separate": false
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/MAX_RECORDS_IN_RAM"
                },
                {
                    "type": "string",
                    "doc": "Base name of output files. Required.",
                    "inputBinding": {
                        "prefix": "OUTPUT=",
                        "separate": false,
                        "position": 2
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/O"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string",
                            "inputBinding": {
                                "prefix": "PROGRAM=",
                                "separate": false
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "List of metrics programs to apply during the pass through the SAM file. Possible values - {CollectAlignmentSummaryMetrics, CollectInsertSizeMetrics, QualityScoreDistribution, MeanQualityByCycle} This option may be specified 0 or more times. This option can be set to 'null' to clear the default list.",
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/PROGRAM"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "prefix": "QUIET=True",
                        "position": 2
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/QUIET"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "REFERENCE_SEQUENCE=",
                        "separate": false,
                        "position": 2
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/REFERENCE_SEQUENCE"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Stop after processing N reads, mainly for debugging. Default value - 0. This option can be set to 'null' to clear the default value.",
                    "inputBinding": {
                        "prefix": "STOP_AFTER=",
                        "position": 2,
                        "separate": false
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/STOP_AFTER"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "doc": "Include unpaired reads in CollectSequencingArtifactMetrics. If set to true then all paired reads will be included as well - MINIMUM_INSERT_SIZE and MAXIMUM_INSERT_SIZE will be ignored in CollectSequencingArtifactMetrics. Default value - false. This option can be set to 'null' to clear the default value. Possible values - {true, false}",
                    "inputBinding": {
                        "prefix": "INCLUDE_UNPAIRED=True",
                        "position": 2
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/UNPAIRED"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "SILENT",
                    "inputBinding": {
                        "prefix": "VALIDATION_STRINGENCY=",
                        "position": 2,
                        "separate": false
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/VALIDATION_STRINGENCY"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "VERBOSITY=",
                        "position": 2,
                        "separate": false
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/VERBOSITY"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n  if (inputs.O)\n    return inputs.O.concat('.insert_size_metrics');\n  return null;\n}\n"
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/is_file"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n  if (inputs.O)\n    return inputs.O.concat('.insert_size_histogram.pdf');\n  return null;\n}\n"
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/is_hist"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${\n  if (inputs.O)\n    return inputs.O.concat('.quality_by_cycle_metrics');\n  return null;\n}\n"
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/qual_file"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${\n  if (inputs.O)\n    return inputs.O.concat('.quality_by_cycle.pdf');\n  return null;\n}\n"
                    },
                    "id": "#picard.CollectMultipleMetrics.cwl/picard-CollectMultipleMetrics/qual_hist"
                }
            ]
        }
    ],
    "cwlVersion": "v1.0"
}
